DebugEnable=0
scanRadioFolder="/tmp/ScanRadio/"
DefaultVif="wifi2_scan"
spectrumOutput="classifier.log"
DefaultAgeOutTime="120"	#time in second for ap sta list entry age out
vif=$1
intervalUnit="ms"	#changes the using of this script, the arg2 unit is ms
interval=$2
device=$3
if [ "$intervalUnit" == "ms" ]; then
DefaultInterval=300
else
DefaultInterval=3
fi
count=0
chIndex=0
athssdEnable=0	#part of spectrum, it takes almost 20 sec to process, disable it now
apStaUpdateInterval=10	#in sec
apStaUpdateCount=0
apStaFilter="/usr/sbin/scanRadio"
preUtilSleepMs=30	#due to the offload counter update every 20 msec, we should wait more than 20 after changed channel to get pure channel counters
default_cfg80211=1
apsteerBoost=0
chIndex_2=0
listIndex=0
ageOutTime=120 #time in second for ap sta list entry age out
spectrum2G_chanlist="3 8 13" # HT40 to scan, change from 3, 8, 13

spectrum5G_chanlist="36 52 100 116 132 140 149 165" # HT80 to scan
spectrum_init=0

ap_rescue="$(uci -q get wifiprofile.snWifiConf.SUPPORT_CLOUD_AP_RESCUE)"
sniffer_enable="$(uci -q get wireless.sniffer.sniffer_enable)"

wids_enable="$(uci -q get wireless.$device.wids_enable)"
deauth_detect="$(uci -q get wireless.$device.deauth_detect)"
eviltwin_detect="$(uci -q get wireless.$device.eviltwin_detect)"
wids_method="$(uci -q get wireless.$device.wids_method)"
if_name=$(uci -q get wireless.$vif.ifname)
tmp_log_dir="/tmp/"$device"_wids_log"
tmp_log_file="snsniffer_log"
tmp_log_path="$tmp_log_dir/$tmp_log_file"

device_if(){
        if [ "$default_cfg80211" == "1" ]; then
                /usr/sbin/cfg80211tool "$@"
        else
                /usr/sbin/iwpriv "$@"
        fi
}


DebugPrint(){
        [ "$DebugEnable" == "1" ] && echo "$@" > /dev/console
}

MSLEEP(){
	sleepms=$(( $1 * 1000))
	usleep $sleepms
}

if [ $sniffer_enable -eq 1 ]; then
SNSNIFFER_AP_STA_LIST_FILENAME="/tmp/ScanRadio/ap_sta_list_scan0-01.csv"
SNSNIFFER_AP_STA_LIST_FILENAME2="/tmp/ScanRadio/ap_sta_list_scan_2-01.csv"
else
AIRODUMP_AP_STA_LIST_FILENAME="/tmp/ScanRadio/ap_sta_list_scan0-01.csv"
AIRODUMP_AP_STA_LIST_FILENAME2="/tmp/ScanRadio/ap_sta_list_scan_2-01.csv"
fi
TMP_AP_LIST_FILENAME="/tmp/ScanRadio/ap_list.txt.tmp"
TMP_STA_LIST_FILENAME="/tmp/ScanRadio/sta_list.txt.tmp"
AP_LIST_FILENAME="/tmp/ScanRadio/ap_list.txt"
AP_LIST_FILENAME_="/tmp/ScanRadio/"$device"_ap_list.txt"
STA_LIST_FILENAME="/tmp/ScanRadio/sta_list.txt"
STA_LIST_FILENAME_="/tmp/ScanRadio/"$device"_sta_list.txt"
RESCUE_LIST_FILENAME="/tmp/ScanRadio/rescue_list.txt"
RESCUE_LIST_FILENAME_="/tmp/ScanRadio/"$device"_rescue_list.txt"

disable_dfs(){
	dev=$1

	radartool -i $dev usenol 0
	radartool -i $dev dfsdebug 1
	radartool -i $dev ignorecac 1
	echo ">>>>>Disable DFS:$dev" > /dev/console
}

disable_beacon(){
	ifname=$1

	device_if $ifname hide_ssid 1
	device_if $ifname dynamicbeacon 1
	echo ">>>>>Disable beacon:$ifname" > /dev/console
}

enable_all_24g_chan(){
	phy=$1

	device_if $phy setCountryID 528
	echo ">>>>>Enable all 24g chan:$phy" > /dev/console
}

processApStaList(){

	ifname=$1
    
	ap_sta_file=$scanRadioFolder"ap_sta_list_"$ifname"-01.csv"
	#echo "==ap_sta_file:$ap_sta_file======" >/dev/console
	if [ -f "$apStaFilter" ]; then
		if [ "$ifname" == "scan_2" ]; then
			if [ $sniffer_enable -eq 1 ]; then
				$apStaFilter -i $SNSNIFFER_AP_STA_LIST_FILENAME2
			else
				$apStaFilter -i $AIRODUMP_AP_STA_LIST_FILENAME2
			fi
		elif [ "$ifname" == "scan_0" ] || [ "$ifname" == "scan_1" ]; then
			$apStaFilter -i $ap_sta_file -a $AP_LIST_FILENAME_ -s $STA_LIST_FILENAME_ -e $ageOutTime
		else
			if [ $sniffer_enable -eq 1 ]; then
				$apStaFilter -i $SNSNIFFER_AP_STA_LIST_FILENAME
			else
				$apStaFilter -i $AIRODUMP_AP_STA_LIST_FILENAME
			fi
		fi
	else
		#separate AP_STA_LIST to ap list and sta list
		if [ $sniffer_enable -eq 1 ]; then
			cat $SNSNIFFER_AP_STA_LIST_FILENAME  | tr -d '\r' | tail -n +3 | sed '/Station MAC/,$d' > $TMP_AP_LIST_FILENAME
			cat $SNSNIFFER_AP_STA_LIST_FILENAME | tr -d '\r' | sed -n '/Station/,$p'| tail -n +2 > $TMP_STA_LIST_FILENAME	
		else
			cat $AIRODUMP_AP_STA_LIST_FILENAME  | tr -d '\r' | tail -n +3 | sed '/Station MAC/,$d' > $TMP_AP_LIST_FILENAME
			cat $AIRODUMP_AP_STA_LIST_FILENAME | tr -d '\r' | sed -n '/Station/,$p'| tail -n +2 > $TMP_STA_LIST_FILENAME
		fi

	#filter entry with channel/rate -1
		cat $TMP_AP_LIST_FILENAME | awk -F ',' '($4 != -1 && $5 != -1){print $0}' > $TMP_AP_LIST_FILENAME
		cat $TMP_STA_LIST_FILENAME | awk -F ',' '($4 != -1){print $0}' > $TMP_STA_LIST_FILENAME

		#filterApListByTime
		#filterStaListByTime

		mv $TMP_AP_LIST_FILENAME $AP_LIST_FILENAME
		mv $TMP_STA_LIST_FILENAME $STA_LIST_FILENAME
	fi
}

filterApListByTime(){

	lineNum=$(sed -n '$=' $TMP_AP_LIST_FILENAME)

	WORKING_FILE="/tmp/ScanRadio/working_list.tmp"

	rm -f $WORKING_FILE

	nowTimeStamp=$(date +%s)
	ageOut=$(uci -q get wireless.$vif.ageOutTime)
	[ -n "$ageOut" ] || ageOut=$DefaultAgeOutTime

	ageOutTimeStamp=$(( $nowTimeStamp - $ageOut))

	for i in `seq 1 $lineNum`; do
		
		time=$(awk -v line=$i -F '[ ,]+' 'NR == line { print $5; exit }' $TMP_AP_LIST_FILENAME)
		timeStamp=$(date +%s -d $time)

		if [ $timeStamp -ge $ageOutTimeStamp ]; then
			head -n $i $TMP_AP_LIST_FILENAME | tail -n 1 >> $WORKING_FILE
		fi
	done
	mv $WORKING_FILE $TMP_AP_LIST_FILENAME
}

filterStaListByTime(){

	lineNum=$(sed -n '$=' $TMP_STA_LIST_FILENAME)

	WORKING_FILE="/tmp/ScanRadio/working_list.tmp"

	rm -f $WORKING_FILE

	nowTimeStamp=$(date +%s)
	ageOut=$(uci -q get wireless.$vif.ageOutTime)
	[ -n "$ageOut" ] || ageOut=$DefaultAgeOutTime

	ageOutTimeStamp=$(( $nowTimeStamp - $ageOut))
        
	for i in `seq 1 $lineNum`; do
                
		time=$(awk -v line=$i -F '[ ,]+' 'NR == line { print $5; exit }' $TMP_STA_LIST_FILENAME)
		timeStamp=$(date +%s -d $time)

		if [ $nowTimeStamp -ge $ageOutTimeStamp ]; then
			head -n $i $TMP_STA_LIST_FILENAME | tail -n 1 >> $WORKING_FILE
		fi
	done
	mv $WORKING_FILE $TMP_STA_LIST_FILENAME
}

check_airodump() {
	vif=$1
	ifname=$(uci -q get wireless.$vif.ifname)

	[ -z "$ifname" ] && {
		DebugPrint "Scan Radio - airodump-ng fail, no ifname:[$ifname] to enable airodump-ng."
		return
	}

	PID_Airo=$(ps -w | grep airodump-ng | grep $ifname | awk '{print $1}')

	if [ -z "$PID_Airo" ]; then
		ap_sta_file_prefix="ap_sta_list_"
		ap_sta_list="$scanRadioFolder""$ap_sta_file_prefix""$ifname"
		rm $ap_sta_list* -rf
                if [ "$ap_rescue" == "1" ]; then
		    screen -d -m airodump-ng $ifname -w $ap_sta_list -K 1 --output-format csv -s 1 -G -B $ageOutTime -L $AP_LIST_FILENAME_ -l $STA_LIST_FILENAME_ -S $RESCUE_LIST_FILENAME_
                else
		    screen -d -m airodump-ng $ifname -w $ap_sta_list -K 1 --output-format csv -s 1 -G -B $ageOutTime -L $AP_LIST_FILENAME_ -l $STA_LIST_FILENAME_
                fi
	fi
}

check_snsniffer() {
	vif=$1
	ifname=$(uci -q get wireless.$vif.ifname)
	snifferEnable=$(uci -q get wireless.$vif.snifferEnable)
	local snsniffer_opt="-"
	
	[ -z "$snifferEnable" ] && return

	[ -z "$ifname" ] && {
		DebugPrint "Scan Radio - snsniffer fail, no ifname:[$ifname] to enable snsniffer."
		return
	}

	PID_snsniffer=$(ps -w | grep snsniffer | grep "$ifname" | awk '{print $1}')

	if [ -z "$PID_snsniffer" ]; then
		ap_sta_file_prefix="ap_sta_list_"
		ap_sta_list="$scanRadioFolder""$ap_sta_file_prefix""$ifname"
		rm $ap_sta_list* -rf

		if [ "$wids_enable" == "1" ]; then
			if [ "$deauth_detect" -eq "1" ] || [ "$eviltwin_detect" -eq "1" ]; then
				#Delete old log
				rm -rf $tmp_log_path
				mkdir -p $tmp_log_dir

				if [ "$eviltwin_detect" -eq "1" ]; then
					snsniffer_opt=$snsniffer_opt"e"
				fi

				if [ "$deauth_detect" -eq "1" ]; then
					snsniffer_opt=$snsniffer_opt"a"
				fi

				if [ "$wids_method" == "3" ]; then #mixed method
					snsniffer_opt=$snsniffer_opt"mb"
				elif [ "$wids_method" == "2" ]; then #mac check method
					snsniffer_opt=$snsniffer_opt"m"
				elif [ "$wids_method" == "1" ]; then #beacon check method
					snsniffer_opt=$snsniffer_opt"b"
				fi

				snsniffer $ifname -w $ap_sta_list -B $ageOutTime -L $AP_LIST_FILENAME_ -l $STA_LIST_FILENAME_ $snsniffer_opt -o $tmp_log_path &
			else
				snsniffer $ifname -w $ap_sta_list -B $ageOutTime -L $AP_LIST_FILENAME_ -l $STA_LIST_FILENAME_ &
			fi
		else
			snsniffer $ifname -w $ap_sta_list -B $ageOutTime -L $AP_LIST_FILENAME_ -l $STA_LIST_FILENAME_ &
		fi

	fi
}

startChanUtil(){	#trigger get_sn_chutil to update cycle_count and rx_clear_count for new channel statistic
	MSLEEP $preUtilSleepMs
	mainSleepInterval=$(( $interval - $preUtilSleepMs ))
	ifname=$1
	device_if $ifname get_sn_chutil > /dev/null
}

saveChanUtil(){

	ifname=$1
	channel=$2
	value=$3

	chUtilList_name="chanUtil.txt"
	chUtilList_name_tmp=$chUtilList_name"_tmp"
	chUtilList=$scanRadioFolder$chUtilList_name
	chUtilList_tmp=$scanRadioFolder$chUtilList_name_tmp

	if [ -z $value ] || [ "$value" == "0" ]; then
		chUtil=$(device_if $ifname get_sn_chutil | awk -F ":" '{print $2}')
		DebugPrint "device_if $ifname get_sn_chutil $chUtil"
	else
		chUtil=$value
		DebugPrint "set chUtil to value $value"
	fi

	if [ "$chUtil" != "255" ]; then 
		[ -e "$chUtilList" ] && cp $chUtilList $chUtilList_tmp		#write in tmp file for synchnization issue
		[ -e "$chUtilList" ] && sed -i '/'channel:$channel'/d' $chUtilList_tmp
		echo channel:$channel	utilization:$chUtil >> $chUtilList_tmp
		DebugPrint "channel:$channel   utilization:$chUtil"
		mv $chUtilList_tmp $chUtilList
	fi
}

chkSpectrumTools(){

	chkSpectraltool=$(type spectraltool | grep is)
	if [ -z "$chkSpectraltool" ]; then
                DebugPrint "no spectraltool, please check your package setting"
		echo 0
		return
	fi
	
	chkAthssd=$(type athssd | grep is)
	if [ -z "$chkAthssd" ]; then
		DebugPrint "no athssd, please check your package setting"
		echo 0
		return
	fi
	echo 1
}

SpectrumAlone(){
	wifi_dev=$1
	channel=$2
	spectrum_default="outFile"
	spectrum_file_name="spectrum_channel_"$channel".txt"
	spectrum_file=$scanRadioFolder$spectrum_file_name
	if [ "$wifi_dev" == "wifi0" ]; then
	        output="/var/run/dolphin/spectrumData_24g"
	else
	        output="/var/run/dolphin/spectrumData_5g"
	fi
	#output=$scanRadioFolder$spectrum_default$wifi_dev
	number=$(uci -q get wireless.$wifi_dev.samples_number)
	spectrum_cmd=""

	#Senao George, don't do it when luci-reload or booting is not finished
	[ ! -e "/tmp/booting_is_done" ] && return

	[ -e "/var/run/luci-reload-status" ] && return

	[ "$spectrum_init" == "0" ] && {
		#Senao George, avoid reinit err
		spectral_pid=$(ps -w | grep spectraltool | grep $wifi_dev | grep get_samples | awk '{print $1}')
		rm -f $output
		if [ -n "$spectral_pid" ]; then
			kill -9 $spectral_pid
			echo ">>>>>[SpectrumAlone]$wifi_dev:Kill Old PID:$spectral_pid" > /dev/console
		fi
		lock -u /var/run/"$wifi_dev"_spectral_lock

		mkdir -p $scanRadioFolder
		spectraltool -i $wifi_dev startscan
		if [ "`cat /tmp/sysinfo/model | grep IPQ40xx`" ]; then
			spectraltool -i $wifi_dev bin_scale 1
		else
			spectraltool -i $wifi_dev bin_scale 0
		fi
		spectraltool -i $wifi_dev fft_size 7
		spectraltool -i $wifi_dev pwr_format 1
		spectraltool -i $wifi_dev stopscan
		spectrum_init=1
		echo ">>>>>[SpectrumAlone]$wifi_dev:ReInit Done" > /dev/console
	}

	lock /var/run/"$wifi_dev"_spectral_lock
	spectraltool -i $wifi_dev startscan

	[ -n "$number" ] && spectrum_cmd=$spectrum_cmd" get_samples $number" || spectrum_cmd=$spectrum_cmd" get_samples 100"
	[ -n "output" ] && spectrum_cmd=$spectrum_cmd" -s $output"
	#Senao George, add quiet to suppress log, you can enable it to debug
	spectraltool -i $wifi_dev $spectrum_cmd quiet
	#[ -s "$output" ] && cp -rf $output $spectrum_file

	spectraltool -i $wifi_dev stopscan
	lock -u /var/run/"$wifi_dev"_spectral_lock
}

StartSpectrum(){	#start spectrum scan
	vif=$1
	channel=$2
	wifi_dev=$(uci -q get wireless.$vif.device)
	ifname=$(uci -q get wireless.$vif.ifname)
	type=$(uci -q get wireless.$vif.spectrum_type)
	number=$(uci -q get wireless.$vif.samples_number)
	output=$scanRadioFolder$spectrumOutput
	athssd_cmd=""

	DebugPrint "StartSpectrum, spectraltool -i $wifi_dev startscan" 
	spectraltool -i $wifi_dev startscan
	spectraltool -i $wifi_dev pwr_format 1
	
	[ -n "$channel" ] && athssd_cmd=$athssd_cmd" -g"
	[ -n "$type" ] && athssd_cmd=$athssd_cmd" -c $type" || athssd_cmd=$athssd_cmd" -c 5"
	[ -n "$number" ] && athssd_cmd=$athssd_cmd" -q $number" || athssd_cmd=$athssd_cmd" -q 32"
	[ -n "output" ] && athssd_cmd=$athssd_cmd" -o $output"

	DebugPrint "StartSpectrum, athssd -i $wifi_dev -j $ifname $athssd_cmd"
	athssd -i $wifi_dev -j $ifname $athssd_cmd &
}

saveSpectrumRawData(){
	vif=$1
	wifi_dev=$(uci -q get wireless.$vif.device)

	DebugPrint "saveSpectrum, spectraltool -i $wifi_dev raw_data &"
        spectraltool -i $wifi_dev raw_data &
}

saveSpectrum(){
	vif=$1
	channel=$2

	spectrum_default_file=$scanRadioFolder$spectrumOutput
	wifi_dev=$(uci -q get wireless.$vif.device)
	
        spectrum_file_name="spectrum_channel_"$channel".txt"
        spectrum_file=$scanRadioFolder$spectrum_file_name

	#DebugPrint "sleep $spectrumDelay for spectraltool raw_data finide"
	#sleep $spectrumDelay

	DebugPrint "saveSpectrum, spectraltool -i $wifi_dev stopscan &"
	spectraltool -i $wifi_dev stopscan

	[ -s "$spectrum_default_file" ] && DebugPrint "mv $spectrum_default_file $spectrum_file" #use -s to check if the file size is not zero
	[ -s "$spectrum_default_file" ] && mv $spectrum_default_file $spectrum_file

	test "$(pgrep -f athssd)" && DebugPrint "saveSpectrum, kill -9 $(pgrep -f athssd)"
	test "$(pgrep -f athssd)" && kill -9 $(pgrep -f athssd)		#term athssd
}

[ -z "$vif" ] && {
	vif=$DefaultVif
	DebugPrint "NO arg1, use default vif $vif"
}

[ -z "$interval" ] && {
	interval=$(uci -q get wireless.$vif.scanInterval)
	if [ -z "$interval" ]; then
		interval=$DefaultInterval
		DebugPrint "NO arg2, no wireless.$vif.scanInterval, use default interval $interval"
	else
		DebugPrint "NO arg2, use wireless.$vif.scanInterval $interval"
	fi
}

ifname=$(uci -q get wireless.$vif.ifname)

wifi_dev=$(uci -q get wireless.$vif.device)
[ -z "$ifname" ] && {
	DebugPrint "NO interface, terminate script. Please check your wireless.$vif.ifname"
	return
}

spectrumMode=$(uci -q get wireless.$wifi_dev.spectrumMode)
chkIfUp=$(iwconfig $ifname | grep Monitor)

[ -z "$chkIfUp" -a "$spectrumMode" != "1" ] && {
	DebugPrint "$ifname did not up, terminate script. Please check your monitor mode function in qcawifi.sh"
	return
}

channelListName="channelList_"$ifname

channelList=$scanRadioFolder$channelListName
channelList_2=$scanRadioFolder"apsteerChannelList"

if [ ! -d $scanRadioFolder ]; then
	mkdir -p $scanRadioFolder
fi 

scanChan=$(uci -q get wireless.$vif.scanChannel)

if [ -n "$scanChan" ]; then	#use user defined channel list
	chan=0
	chCount=1
	while [ ! -z "$chan" ]; do
		chan=$(uci -q get wireless.$vif.scanChannel | awk '{print $'$chCount'}')
		[ -n "$chan" ] && echo "$chan" >> $channelList
		chCount=$(($chCount + 1))        
	done
else
	scanchan_mode=$(uci -q get wireless.$vif.scanchan_mode) # 0:both 2.4G and 5G, 1:only 2.4G, 2:only 5G
	#use radio suppoted channel list
	if [ "$scanchan_mode" == "0" ]; then
		iwlist $ifname channel | grep "Channel" | awk -F" " '{ print $2 }' > $channelList

		chan_2G=$(cat $channelList | awk -F" " '{if ($1 >= 1 && $1 <= 14) print $1 }')
		chan_5G=$(cat $channelList | awk -F" " '{if ($1 >= 36) print $1 }')
		[ -z "$chan_2G" ] && echo "Scan Radio Warning: The hardware does not support 2.4G, but scanchan_mode selects to scan both 2.4G and 5G radio." > /dev/console
		[ -z "$chan_5G" ] && echo "Scan Radio Warning: The hardware does not support 5G, but scanchan_mode selects to scan both 2.4G and 5G radio." > /dev/console
	elif [ "$scanchan_mode" == "1" ]; then
		iwlist $ifname channel | grep "Channel" | awk -F" " '{if ($2 >= 1 && $2 <= 14) print $2 }' > $channelList
	elif [ "$scanchan_mode" == "2" ]; then
		iwlist $ifname channel | grep "Channel" | awk -F" " '{if ($2 >= 36) print $2 }' > $channelList
	else
		iwlist $ifname channel | grep "Channel" | awk -F" " '{ print $2 }' > $channelList
	fi

	chanStr=$(cat $channelList)

	[ -z "$chanStr" ] && {
		echo "Scan Radio ERROR: The channel list has no channel to switch." > /dev/console
		return
	}
fi

updateInterval=$(uci -q get wireless.$vif.updateApStaInterval)

[ -n $updateInterval -a $updateInterval -ge 1 ] && apStaUpdateInterval=$updateInterval

[ "$intervalUnit" == "ms" ] && apStaUpdateInterval=$(( $apStaUpdateInterval * 1000))

apStaUpdateLimit=$(( $apStaUpdateInterval / interval ))

spctrumTool=$(chkSpectrumTools)

# avoid the interface not yet enabled before scan spectrum, causing vap cannot work.
[ "$spectrumMode" == "1" ] && {
	#Senao George, fix vap not up                                         
	ifconfig $ifname up  
	is2G=$(iwlist $ifname chan | grep "Current" | awk -F " " '{if ($2 >= 1 && $2 <= 14) print $2 }')
	support_channel_14=$(iwlist $ifname chan | grep "Channel 14")
	sleep 5
	if [ "$wifi_dev" == "wifi1" ]; then
		#Senao George, disable dfs for better smoothing scan effect
		disable_dfs $wifi_dev
	fi
	
	if [ "$wifi_dev" == "wifi0" ];then
		enable_all_24g_chan $wifi_dev
	fi
	disable_beacon $ifname
}

while :
do
	spectrumMode=$(uci -q get wireless.$wifi_dev.spectrumMode)
	scanProgress=$(uci -q get wireless.$vif.scanProgress)	#0 STOP, 1 SCAN, 2 PAUSE

	if [ "$spectrumMode" != "1" ]; then
		if [ -z "$scanProgress" ]; then
			DebugPrint "no scanProgress option in wireless.$vif, terminate scanRadio script"
			break;
		elif [ "$scanProgress" == "2" ]; then
			DebugPrint "scanProgress=$scanProgress, PAUSE, sleep $interval"
			sleep $interval
			continue;
		elif [ "$scanProgress" == "0" ]; then
			DebugPrint "scanProgress=$scanProgress, Force terminate scanRadio script"
			break;
		fi

		chanUtilEnable=$(uci -q get wireless.$vif.chanUtilEnable)
		spectrumEnable=$(uci -q get wireless.$vif.spectrumEnable)

		channelNum=$(sed -n '$=' "$channelList")
		[ -e "$channelList_2" ] && channelNum_2=$(sed -n '$=' "$channelList_2")

	        chIndex=$(( ($count % $channelNum ) + 1 ))

	        if [ "$apsteerBoost" == "1" -a $channelNum_2 -ge 1 ];then
			chIndex_2=$(( ($count / 2 % $channelNum_2 ) + 1 ))
			chIndex=$(( ($chIndex / 2) + 1))
	        fi


		if [ "$apsteerBoost" == "1" ]; then
			listIndex=$(($count % 2))
		fi
		if [ "$listIndex" == "1" ]; then
			channel=$(cat $channelList_2 | head -n $chIndex_2 | tail -n 1)
		else
			channel=$(cat $channelList | head -n $chIndex | tail -n 1)
		fi

		DebugPrint "set $ifname channel to $channel, chIndex=$chIndex count=$count"

		#check airodump / snsniffer if exist
		if [ $sniffer_enable -eq 1 ]; then
			check_snsniffer $vif
		else
			check_airodump $vif
		fi

		#switch channel
		[ "$channel" != "$setChannel" ] && iwconfig $ifname channel $channel

		#sleep scan interval
		DebugPrint "Sleep $interval"

		mainSleepInterval=$interval

		setChannel=$channel

		#start scan here
		[ "$chanUtilEnable" == "1" ] && sumUtil=0
		[ "$spectrumEnable" == "1" ] && [ "$spctrumTool" == "1" ] && StartSpectrum "$vif" "$channel"
		[ "$spectrumEnable" == "0" ] && spectrumDelay=0

		[ "$chanUtilEnable" == "1" ] && startChanUtil $ifname

		if [ "$intervalUnit" != "ms" ]; then
			sleepCount=1
			sleepTime=$(( $interval - $spectrumDelay ))
		fi
		#end

		#process ap_sta_list, entry filter
		apStaUpdateCount=$(( $apStaUpdateCount + 1))
		if [ $apStaUpdateCount -ge $apStaUpdateLimit ]; then
			processApStaList $ifname
			apStaUpdateCount=0;
		fi

		if [ "$intervalUnit" == "ms" ]; then
			MSLEEP $mainSleepInterval
		else
			while [ $sleepCount -le $sleepTime ]; do	#sleep 1 sec in every loop

				[ "$chanUtilEnable" == "1" ] && {
					util=$(device_if $ifname get_chutil | awk -F ":" '{print $2}')
					sumUtil=$(( $sumUtil + $util ))
					DebugPrint "sleepCount=$sleepCount, util=$util, sumUtil=$sumUtil"
				}
		
				sleep 1
				sleepCount=$(( $sleepCount + 1 ))
			done
		fi
		#end sleep

		#end of routine on this channel
		[ "$chanUtilEnable" == "1" ] && {
			if [ "$intervalUnit" == "ms" ]; then
				saveChanUtil $ifname $channel
			else
				avgUtil=0
				[ $sumUtil -gt 0 ] && avgUtil=$(( $sumUtil / $sleepTime ))  #not to use sleepCount, use sleepTime because the while loop condition is -le
				saveChanUtil $ifname $channel $avgUtil
			fi
		}
	
		[ "$spectrumEnable" == "1" ] && [ "$spctrumTool" == "1" ] && saveSpectrum "$vif" "$channel"
		#end
	else
		#t1=$(($(date +%s%N)/1000000)) #ms
		if [ -z "$is2G" ]; then
			channelNum=$(echo $spectrum5G_chanlist | awk '{print NF}')
		else
			if [ "$support_channel_14" ]; then
				channelNum=$(echo $spectrum2G_14_chanlist | awk '{print NF}')
			else
				channelNum=$(echo $spectrum2G_chanlist | awk '{print NF}')
			fi
		fi

		chIndex=$(( ($count % $channelNum ) + 1 ))

		if [ -z "$is2G" ]; then
			channel=$(echo $spectrum5G_chanlist | awk '{print $'$chIndex'}')
		else
			if [ "$support_channel_14" ]; then
				channel=$(echo $spectrum2G_14_chanlist | awk '{print $'$chIndex'}')
			else
				channel=$(echo $spectrum2G_chanlist | awk '{print $'$chIndex'}')
			fi
		fi

		#Senao George, don't do it when luci-reload or booting is not finished
		[ ! -e "/tmp/booting_is_done" ] && continue

		[ -e "/var/run/luci-reload-status" ] && continue

		[ "$channel" != "$setChannel" ] && iwconfig $ifname channel $channel || (echo "wifi:$wifi_dev ch:$channel set channel fail. Skip ch:$channel spectral scan" > /dev/console; sleep 8; continue) #DFS radar or resource too busy in wifi driver will cause this exception
		setChannel=$channel
		#sleep 1 #Minumum time to change channel
		SpectrumAlone "$wifi_dev" "$channel"
		#t2=$(($(date +%s%N)/1000000)) #ms
		#t3=`expr $t2 - $t1`
		#echo "wifi:$wifi_dev ch:$channel start_time:$t1 end_time:$t2 total_time:$t3" > /dev/console
	fi

	count=$(( $count + 1 ))
done 

DebugPrint "End of ScanRadio.sh"
